
    <!DOCTYPE html>
    <html>
      <head>
        <meta charset="utf-8">
      </head>
      <body>
        <div class="marpit"><svg data-marpit-svg="" viewBox="0 0 1280 5000"><foreignObject width="1280" height="5000"><section id="1" data-marpit-fragments="23">
<h1>ORM</h1>
<p>ORM (Object-Relation Mapping) – общее название для фреймворков, позволяющих автоматически связать базу данных с кодом. Они стараются скрыть существование базы данных настолько, насколько это возможно. Взамен, программисту дают возможность оперировать данными в базе через специальный интерфейс. Вместо построения SQL-запросов, программист вызывает простые методы, а всю остальную работу берёт на себя ORM.</p>
<p>Сущности предметной области существуют не сами по себе. Они часто зависят друг от друга. В этом домашнем задании мы будем работать с двумя связанными сущностями — с категориями и статьями. Категории связанны со статьями связью &quot;один ко многим&quot;. Одна категория может содержать множество статей, но любая статья всегда находится только в одной категории.</p>
<h2>Ссылки</h2>
<ul>
<li data-marpit-fragment="1"><a href="https://javaee.github.io/javaee-spec/javadocs/javax/persistence/Entity.html">Аннотация @Entity — указывает, что класс является моделью</a></li>
<li data-marpit-fragment="2"><a href="https://javaee.github.io/javaee-spec/javadocs/javax/persistence/ManyToOne.html">Аннотация @ManyToOne — задаёт связь &quot;многие к одному&quot;</a></li>
<li data-marpit-fragment="3"><a href="https://javadoc.io/doc/io.ebean/ebean-annotation/latest/io/ebean/annotation/NotNull.html">Аннотация @NotNull — устанавливает на поле ограничение NOT NULL</a></li>
<li data-marpit-fragment="4"><a href="https://javaee.github.io/javaee-spec/javadocs/javax/persistence/Lob.html">Аннотация @Lob — определяет, что содержимым поля может быть большой объект, например текст</a></li>
<li data-marpit-fragment="5"><a href="https://ebean.io/docs/query/query-beans">Query beans — удобный способ написания запросов</a></li>
<li data-marpit-fragment="6"><a href="https://ebean.io/docs/query/select">Выборка Select</a></li>
<li data-marpit-fragment="7"><a href="https://ebean.io/docs/query/where">Условия выборки Where</a></li>
<li data-marpit-fragment="8"><a href="https://ebean.io/apidoc/11/io/ebean/PagedList.html">Интерфейс PagedList — представляет одну страницу результата</a></li>
</ul>
<h2>src/main/resources/application.yml</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="9">Изучите содержимое файла <em>application.yml</em>, в котором происходит настройка ORM. Обратите внимание на комментарии.</li>
</ul>
<h2>src/main/java/exercise/domain/Category.java</h2>
<p>Модель — это воплощение понятия предметной области в коде приложения. В Ebean каждая модель представлена классом в коде и таблицей в базе данных.</p>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="10">Изучите класс <code>Category</code>, который представляет собой модель категории. Обратите внимание, что модель наследуется от класса <code>io.ebean.Model</code>. Благодаря этому на модели можно вызывать <a href="https://ebean.io/docs/intro/first-entity/model">метод save()</a> для сохранения данных в базу. Изучите аннотации, которыми отмечены класс и поля класса.</li>
</ul>
<h2>src/main/java/exercise/domain/Article.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="11">
<p>Допишите модель статьи <code>Article</code>.</p>
<ul>
<li data-marpit-fragment="12">
<p>Создайте в классе конструктор, который принимает в качестве аргументов название статьи, её содержание и категорию статьи.</p>
<pre><code class="language-java">Category category = ... <span class="hljs-comment">// получаем категорию из базы</span>
String title = <span class="hljs-string">&quot;New article&quot;</span>;
String body = <span class="hljs-string">&quot;Text of article&quot;</span>;
Article article = <span class="hljs-keyword">new</span> Article(title, body, category);
</code></pre>
</li>
<li data-marpit-fragment="13">
<p>Создайте геттеры для получения значения всех полей: <code>getId()</code>, <code>getTitle()</code>, <code>getBody()</code>, <code>getCategory()</code>.</p>
</li>
</ul>
</li>
</ul>
<h2>src/main/java/exercise/MigrationGenerator.java</h2>
<p>Миграция в ORM — это файл, который содержит SQL-запросы, создающие схему базы данных. ORM позволяет автоматически генерировать миграции на основании моделей. Для этого нужен файл <em>MigrationGenerator.java</em>.</p>
<ul>
<li data-marpit-fragment="14">
<p>Изучите код в этом файле.</p>
</li>
<li data-marpit-fragment="15">
<p>Изучите таску Gragle <code>generateMigrations</code> в файле <em>build.gradle</em>, которая запускает создание миграций.</p>
</li>
<li data-marpit-fragment="16">
<p>При помощи команды <code>gradle generateMigrations</code> сгенерируйте миграции. Изучите получившиеся файлы миграции в директории <em>src/main/java/exercise/resources/dbmigration</em>.</p>
</li>
</ul>
<h2>src/main/java/exercise/servlet/ArticlesServlet.java</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="17">
<p>Допишите метод <code>showArticles()</code>, который выводит список статей с пейджингом. Статьи должны быть отсортированы по id в порядке возрастания. В одном из предыдущих заданий мы формировали такой запрос вручную. Теперь сделайте это при помощи ORM. Для этого вам понадобится интерфейс <a href="https://ebean.io/apidoc/11/io/ebean/PagedList.html">PagedList</a>. Получите из базы список <code>List</code> статей <code>Article</code> и установите его в качестве значения для атрибута &quot;articles&quot;.</p>
</li>
<li data-marpit-fragment="18">
<p>Допишите метод <code>showAricle()</code>, который выводит страницу просмотра статьи. При помощи ORM получите из базы данных статью <code>Article</code> по её id и установите её в качестве значения для атрибута &quot;article&quot;.</p>
</li>
<li data-marpit-fragment="19">
<p>Допишите метод <code>newArticle()</code>, который выводит страницу создания новой статьи. При создании новой статьи нужно будет указать категорию, к которой эта статья относится. Для этого нужно передать в шаблон список категорий. Получите список <code>List</code> всех категорий <code>Category</code> и установите его в качестве значения для атрибута &quot;categories&quot;.</p>
</li>
<li data-marpit-fragment="20">
<p>Допишите метод <code>createArticle()</code>, который создаёт новую статью и добавляет её в базу данных. Для создания статьи используйте созданный ранее конструктор.</p>
</li>
</ul>
<h2>src/main/webapp/WEB-INF/articles/show.html</h2>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="21">На странице просмотра статьи реализуйте вывод названия категории, которой принадлежит статья.</li>
</ul>
<h2>Подсказки</h2>
<ul>
<li data-marpit-fragment="22">Чтобы получить список статей <code>List</code> из <code>PagedList</code>, воспользуйтесь методом <a href="https://ebean.io/apidoc/11/io/ebean/PagedList.html#getList--">getList()</a></li>
<li data-marpit-fragment="23">Изучите файл с примерами <em>Examples/Example.java</em>.</li>
</ul>
</section>
<script>!function(){"use strict";const t="marpitSVGPolyfill:setZoomFactor,",e=Symbol();let r,o;function n(n){const i="object"==typeof n&&n.target||document,a="object"==typeof n?n.zoom:n;window[e]||(Object.defineProperty(window,e,{configurable:!0,value:!0}),window.addEventListener("message",(({data:e,origin:r})=>{if(r===window.origin)try{if(e&&"string"==typeof e&&e.startsWith(t)){const[,t]=e.split(","),r=Number.parseFloat(t);Number.isNaN(r)||(o=r)}}catch(t){console.error(t)}})));let l=!1;Array.from(i.querySelectorAll("svg[data-marpit-svg]"),(t=>{var e,n,i,s;t.style.transform||(t.style.transform="translateZ(0)");const c=a||o||t.currentScale||1;r!==c&&(r=c,l=c);const d=t.getBoundingClientRect(),{length:u}=t.children;for(let r=0;r<u;r+=1){const o=t.children[r],a=o.getScreenCTM();if(a){const t=null!==(n=null===(e=o.x)||void 0===e?void 0:e.baseVal.value)&&void 0!==n?n:0,r=null!==(s=null===(i=o.y)||void 0===i?void 0:i.baseVal.value)&&void 0!==s?s:0,l=o.firstElementChild,{style:u}=l;u.transformOrigin||(u.transformOrigin=`${-t}px ${-r}px`),u.transform=`scale(${c}) matrix(${a.a}, ${a.b}, ${a.c}, ${a.d}, ${a.e-d.left}, ${a.f-d.top}) translateZ(0.0001px)`}}})),!1!==l&&Array.from(i.querySelectorAll("iframe"),(({contentWindow:e})=>{null==e||e.postMessage(`${t}${l}`,"null"===window.origin?"*":window.origin)}))}r=1,o=void 0;const i=(t,e,r)=>{if(t.getAttribute(e)!==r)return t.setAttribute(e,r),!0};function a({once:t=!1,target:e=document}={}){const r="Apple Computer, Inc."===navigator.vendor?[n]:[];let o=!t;const a=()=>{for(const t of r)t({target:e});!function(t=document){Array.from(t.querySelectorAll('svg[data-marp-fitting="svg"]'),(t=>{var e;const r=t.firstChild,o=r.firstChild,{scrollWidth:n,scrollHeight:a}=o;let l,s=1;if(t.hasAttribute("data-marp-fitting-code")&&(l=null===(e=t.parentElement)||void 0===e?void 0:e.parentElement),t.hasAttribute("data-marp-fitting-math")&&(l=t.parentElement),l){const t=getComputedStyle(l),e=Math.ceil(l.clientWidth-parseFloat(t.paddingLeft||"0")-parseFloat(t.paddingRight||"0"));e&&(s=e)}const c=Math.max(n,s),d=Math.max(a,1),u=`0 0 ${c} ${d}`;i(r,"width",`${c}`),i(r,"height",`${d}`),i(t,"preserveAspectRatio",getComputedStyle(t).getPropertyValue("--preserve-aspect-ratio")||"xMinYMin meet"),i(t,"viewBox",u)&&t.classList.toggle("__reflow__")}))}(e),o&&window.requestAnimationFrame(a)};return a(),()=>{o=!1}}const l=Symbol(),s=document.currentScript;((t=document)=>{if("undefined"==typeof window)throw new Error("Marp Core's browser script is valid only in browser context.");if(t[l])return t[l];const e=a({target:t}),r=()=>{e(),delete t[l]};Object.defineProperty(t,l,{configurable:!0,value:r})})(s?s.getRootNode():document)}();
</script></foreignObject></svg></div>
      </body>
    </html>
  
